import { zodResolver } from '@hookform/resolvers/zod'
import { data } from 'react-router'
import { getValidatedFormData } from 'remix-hook-form'
import { XiorError } from 'xior'

import { getUser } from '~/apis/news/get-user'
import {
  subscribeSchema,
  type TSubscribeSchema,
} from '~/layouts/news/form-subscription'
import { handleCookie } from '~/libs/cookies'

import type { Route } from './+types/actions.register'

export const action = async ({ request }: Route.ActionArgs) => {
  const { userToken } = await handleCookie(request)
  try {
    const {
      errors,
      data: payload,
      receivedValues: defaultValues,
    } = await getValidatedFormData<TSubscribeSchema>(
      request,
      zodResolver(subscribeSchema),
      false,
    )

    if (errors) {
      return data({ success: false, errors, defaultValues }, { status: 400 })
    }

    // TODO: implement subscribe
    console.log('payload', payload) // eslint-disable-line no-console

    const { data: userData } = await getUser({
      accessToken: userToken,
    })

    return data(
      {
        success: true,
        user: userData,
      },
      {
        status: 200,
        statusText: 'OK',
      },
    )
  } catch (error) {
    if (error instanceof XiorError) {
      return data(
        {
          success: false,
          message: error?.response?.data?.error?.message || error.message,
        },
        {
          status: error?.response?.status || 500,
        },
      )
    }
    return data(
      {
        success: false,
        message: 'Internal server error',
      },
      { status: 500 },
    )
  }
}
